/*
RTW-particle.h - Library for sending and recieving data over RTW.
Created by Martin Wahlberg, January 18, 2019.
Released into the public domain.
*/
#include "Particle.h"
#include "RTWparticle.h"

TCPClient rtw_GET;
TCPClient rtw_Send;

RTWparticle::RTWparticle()
{

}

void RTWparticle::initGet(String host, String service, String objectID, String auth){
  Serial.begin(9600);



  String requestFirst = "POST /" + service + "?objectID=" + objectID + "&" + auth + " HTTP/1.1";
  Serial.println("Connection Started");
  if (rtw_GET.connect(host, 80))
  {
    rtw_GET.println(requestFirst);
    rtw_GET.println("Synx-Cat: 4");
    rtw_GET.println("Accept: application/xml");
    rtw_GET.println("Host: " + host);
    rtw_GET.println("Connection: keep-alive");
    rtw_GET.println("Content-Length: 0");
    rtw_GET.println();


  }
  else
  {
  Serial.println("connection failed");
  }
  Serial.println("Connection finished");

}

String RTWparticle::getNewMessages()
{
  String s = "";
  if (rtw_GET.available()){
  rtw_GET.setTimeout(100);
  for (int i=0; i <= rtw_GET.available(); i++){
  s = rtw_GET.readString();
  if(s.indexOf("<RTW>") > 0){
  s.remove(0, s.indexOf("<RTW>"));
  s.remove(s.indexOf("</RTW>") + 6, s.length());
  return s;
  }
}}
if(!rtw_GET.connected()){
  setup();
}
return "";
}


void RTWparticle::sendRTW(String service, String objId, String auth, String query, String url){
  query.replace(" ", "%20");
  String requestFirst = "POST /" + service + "?objectID=" + objId + "&" + auth + "&" + query + " HTTP/1.1";
  if (rtw_Send.connect(url, 80))
  {

    rtw_Send.println(requestFirst);
    rtw_Send.println("Synx-Cat: 1");
    rtw_Send.println("Accept: application/xml");
    rtw_Send.println("Host: " + url);
    rtw_Send.println("Connection: close");
    rtw_Send.println("Content-Length: 0");
    rtw_Send.println();
  }
  else
  {
    Serial.println("connection failed");
  }
  }


String RTWparticle::parseRTW(String rtw_Message, String want){
    want.toUpperCase();
    String s = rtw_Message;
    int sL = want.length() + 2;
    s.remove(0, s.indexOf("<"+want+">") + sL);
    s.remove(s.indexOf("</"+want+">"), s.length());
    return s;
}
